       program grid_gen
       implicit none
c
       integer N,M
       parameter (N=99, M=100)
c
       integer   i,j
       real*16    lam,factor(M)
       real*16    temp1, temp2 
       real*16    air0(2,N), air(2,N)
       real*16    coef(3),b,c,d,e
       complex*16 psi(N,M),z(N,M),tmp1,tmp2
c
       lam = 0.495d0
       b   = 4.0d0
       c   = 4.0d0
       d   = 1.50d0
       e   = 7.0d0
c
       open(1,file='scaledAirfoil.dat',status='old')
c
       do i = 1,N
         read(1,*) air(1,i), air(2,i)
         air0(1,i) = air(1,i)
         air0(2,i) = air(2,i)
       enddo 
c
       close(1)
c
c Grid Perturbation in the three modes.
c
c Angle of Attack
c
       do i = 1,N
        air(1,i) = cos(coef(2))*air0(1,i) + sin(coef(2))*air0(2,i)
        air(2,i) = cos(coef(2))*air0(2,i) - sin(coef(2))*air0(1,i)
       enddo
c
c Thickness Perturbation
c
       do i = 1, (N+1d0)/2d0
         air(2,i) = air0(2,i) + 
     &        0.04*coef(1)*(air0(1,i)**(b-1))*((1-air0(1,i))**(c-1))
       enddo
       do i = (N+3d0)/2d0, N
         air(2,i) = air0(2,i) -
     &        0.04*coef(1)*(air0(1,i)**(b-1))*((1-air0(1,i))**(c-1))
       enddo
c
c Leading Edge
c
       do i = 1, (N+1d0)/2d0
         air(2,i) = air0(2,i) -
     &       0.02*coef(3)*(air0(1,i)**(d-1))*((1-air0(1,i))**(e-1))
       enddo
       do i = (N+3d0)/2d0, N
         air(2,i) = air0(2,i) +
     &       0.02*coef(3)*(air0(1,i)**(d-1))*((1-air0(1,i))**(e-1))
       enddo
c
       do i = 1,N
         air(1,i) = air(1,i)*2.0d0 - 1.0d0
         air(2,i) = air(2,i)*2.0d0
         z(i,1) = dcmplx(air(1,i),air(2,i))
         tmp1 = (z(i,1) + cdsqrt(z(i,1)*z(i,1) - 4*lam*lam))/2.0
         tmp2 = (z(i,1) - cdsqrt(z(i,1)*z(i,1) - 4*lam*lam))/2.0
         if(cabs(tmp1).gt.cabs(tmp2))then
           psi(i,1) = tmp1
         else
           psi(i,1) = tmp2
         endif
       enddo
c
       factor(1) = 1.0d0
       do i=2,M
         factor(i) = 1.05d0**(i-1)
       enddo
c
       do i=1,N
         temp1 = (i-1)*360.0d0/real(N-1)*atan(1.0d0)/45.0d0
         psi(i,M) = dcmplx(factor(M)*0.5d0*dcos(temp1), 
     &                     factor(M)*0.50d0*dsin(temp1))
       enddo
c
       do i = 1, M
         temp1 = (real(factor(i)) - 1.0d0)/(real(factor(M)) - 1.0d0)
         do j = 1, N
           psi(j,i) = psi(j,1)*(1.0d0-temp1) + psi(j,M)*temp1
         enddo
       enddo
c    
       open(1,file='psi.dat',status='old')
         do j = 1, N         
       do i = 1, M
           write(1,*) psi(j,i)
         enddo 
       enddo 
       close(1)
c
       do i = 1, M
         do j = 1, N         
            z(j,i) = psi(j,i) + lam*lam/psi(j,i)
         enddo
       enddo
c
       open(1,file='grid.dat',status='old')
       do i = 1, M
         do j = 1, N         
           temp1 = real(z(j,i))
           temp2 = imag(z(j,i))
           z(j,i) = dcmplx((temp1+1.0d0)*0.5d0,temp2*0.5d0)
           write(1,100) z(j,i)
         enddo
       enddo
       close(1)
c
 100    format(e23.16,' ',e23.16)
 101    format(e23.16,' ',e23.16,' ',e23.16,' ',e23.16)
c
       stop
       end
