ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                   c
c      Hessian airfoil lift perturbation calculation                c
c      using linearised routines created by Tapenade                c
c                                                                   c
c      Copyright Devendra Ghate and Mike Giles, 2006                c
c      but can be freely used with due acknowledgement              c
c                                                                   c
c      Tapenade developed by Laurent Hascoet and others at INRIA    c
c                                                                   c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
        program air_hes
        implicit none
c
#include "const.inc"
c
        integer    maxnode,     maxcell,       maxedge
        parameter (maxnode=9900,maxcell=9702+1,maxedge=19502)
c
        integer*4 ecell(2,maxedge), boun(maxedge),
     &            edge(2,maxedge), cell(4,maxcell)
c
        real*8    x(2,maxnode), xd(2,maxnode),x0(2),
     &            xd0(2,maxnode), xdd(2,maxnode),
     &            q(4,maxcell), qd(4,maxcell), 
     &            qd0(4,maxcell), qdd(4,maxcell), 
     &            qb(4,maxcell), qd1(4,maxcell),
     &            qd2(4,maxcell),qd3(4,maxcell),
     &            pert1(2,maxnode),pert3(2,maxnode),
     &            adt(maxcell), adtd(maxcell),
     &            adtd0(maxcell), adtdd(maxcell),
     &            res(4,maxcell), resd(4,maxcell),
     &            resd0(4,maxcell), resdd(4,maxcell),
     &            x_m(2,maxnode)
c
        real*8    lift, liftd, liftd0, liftdd,
     &            Dlift, alp,alpd0,alpd,alpdd,
     &            maxres(4), maxresd(4), maxresd0(4)
c
        integer*4 in,in1,in2,in3,in4,ic,ic1,ic2,ie,ipde,
     &            k, nnode,ncell,nedge,il1,il2,il
c
        real*8    coefd0(3),coefd(3),coefdd(3),
     &            liftdd1,hes(3,3)
c
c------ read in grid and flow data
c
        call input(maxnode,maxcell,maxedge, nnode,ncell,nedge,
     &             x, q,cell, edge,ecell,boun,pert1,pert3)
c
        do in=1,nnode
          x_m(1,in) = x(1,in)
          x_m(2,in) = x(2,in)
        enddo
        call input_hes(maxcell, ncell,qd1,qd2,qd3,qb)
c
      do il1=3,1,-1
      do il2=1,3
          
c        il1 = 2
c        il2 = 1
c
        do il=1,3
          coefd(il)  = 0.0d0
          coefd0(il) = 0.0d0
          coefdd(il) = 0.0d0
        enddo
c
        if(il1.eq.2)then
          coefd(il1) = datan(1.0d0)/45.0d0
        else
          coefd(il1) = 1.0d0
        endif
        if(il2.eq.2)then
          coefd0(il2)  = datan(1.0d0)/45.0d0
        else
          coefd0(il2)  = 1.0d0
        endif
c
        do in=1,nnode
          do ipde=1,2
            x(ipde,in)   = x_m(ipde,in)
            xd(ipde,in)  = 0.0d0
            xd0(ipde,in) = 0.0d0
            xdd(ipde,in) = 0.0d0
          enddo
        enddo
c
        do in=1, nnode
          x0(1) = x(1,in)
          x0(2) = x(2,in)
          call grid_gen_dx2(coef,coefd0,coefd,coefdd, 
     &                      pert1(1,in), pert3(1,in),
     &             x0(1),x(1,in),xd0(1,in),xd(1,in),xdd(1,in))
        enddo
c
c------ Intializing qd0 and qd1, qd2, qd3, qdd.
c
           if(il1.eq.1)then
             do ic=1,ncell
               qd(1,ic)=qd1(1,ic)
               qd(2,ic)=qd1(2,ic)
               qd(3,ic)=qd1(3,ic)
               qd(4,ic)=qd1(4,ic)
             enddo
           elseif(il1.eq.2)then
             do ic=1,ncell
               qd(1,ic)=qd2(1,ic)
               qd(2,ic)=qd2(2,ic)
               qd(3,ic)=qd2(3,ic)
               qd(4,ic)=qd2(4,ic)
             enddo
           elseif(il1.eq.3)then
             do ic=1,ncell
               qd(1,ic)=qd3(1,ic)
               qd(2,ic)=qd3(2,ic)
               qd(3,ic)=qd3(3,ic)
               qd(4,ic)=qd3(4,ic)
             enddo
           endif
c
           if(il2.eq.1)then
             do ic=1,ncell
               qd0(1,ic)=qd1(1,ic)
               qd0(2,ic)=qd1(2,ic)
               qd0(3,ic)=qd1(3,ic)
               qd0(4,ic)=qd1(4,ic)
             enddo
           elseif(il2.eq.2)then
             do ic=1,ncell
               qd0(1,ic)=qd2(1,ic)
               qd0(2,ic)=qd2(2,ic)
               qd0(3,ic)=qd2(3,ic)
               qd0(4,ic)=qd2(4,ic)
             enddo
           elseif(il2.eq.3)then
             do ic=1,ncell
               qd0(1,ic)=qd3(1,ic)
               qd0(2,ic)=qd3(2,ic)
               qd0(3,ic)=qd3(3,ic)
               qd0(4,ic)=qd3(4,ic)
             enddo
           endif

        do ic = 1, ncell
          do ipde = 1, 4
            qdd(ipde,ic)   = 0.0d0
            res(ipde,ic)   = 0.0d0
            resd(ipde,ic)  = 0.0d0
            resd0(ipde,ic) = 0.0d0
            resdd(ipde,ic) = 0.0d0
          enddo
        enddo
c
        do ic=1, ncell
          adt(ic)   = 0.0d0
          adtd(ic)  = 0.0d0
          adtd0(ic) = 0.0d0
          adtdd(ic) = 0.0d0
        enddo
c
c------ time cell calculation
c
        do ic=1, ncell-1
          in1 = cell(1,ic)
          in2 = cell(2,ic)
          in3 = cell(3,ic)
          in4 = cell(4,ic)
        call time_cell_dx2(x(1,in1),xd0(1,in1),xd(1,in1),xdd(1,in1),
     &                      x(1,in2),xd0(1,in2),xd(1,in2),xdd(1,in2), 
     &                      x(1,in3),xd0(1,in3),xd(1,in3),xdd(1,in3), 
     &                      x(1,in4),xd0(1,in4),xd(1,in4),xdd(1,in4), 
     &                      q(1,ic),qd0(1,ic),qd(1,ic),qdd(1,ic), 
     &                      adt(ic),adtd0(ic),adtd(ic),adtdd(ic))
        enddo
c
        adt(ncell)   = 0.0d0
        adtd(ncell)  = 0.0d0
        adtd0(ncell) = 0.0d0
        adtdd(ncell) = 0.0d0
c
        do ie=1, nedge
          in1 = edge(1,ie)
          in2 = edge(2,ie)
          ic1 = ecell(1,ie)
          ic2 = ecell(2,ie)
c
c---------Flux calculations.
c
          if(boun(ie).eq.0) then
            call flux_face_dx2(
     &            x(1,in1), xd0(1,in1),xd(1,in1),xdd(1,in1),
     &            x(1,in2), xd0(1,in2),xd(1,in2),xdd(1,in2),
     &            q(1,ic1), qd0(1,ic1),qd(1,ic1), qdd(1,ic1),
     &            q(1,ic2), qd0(1,ic2),qd(1,ic2), qdd(1,ic2),
     &            adt(ic1), adtd0(ic1),adtd(ic1),adtdd(ic1),
     &            adt(ic2), adtd0(ic2),adtd(ic2),adtdd(ic2),
     &            res(1,ic1), resd0(1,ic1),resd(1,ic1),resdd(1,ic1),
     &            res(1,ic2), resd0(1,ic2),resd(1,ic2),resdd(1,ic2))
          elseif (boun(ie).eq.1) then
            call flux_wall_dx2(
     &            x(1,in1), xd0(1,in1),xd(1,in1),xdd(1,in1),
     &            x(1,in2), xd0(1,in2),xd(1,in2),xdd(1,in2),
     &            q(1,ic2), qd0(1,ic2),qd(1,ic2), qdd(1,ic2),
     &            res(1,ic2), resd0(1,ic2),resd(1,ic2),resdd(1,ic2))
          endif
        enddo
c
        lift   = 0.0d0
        liftd0 = 0.0d0
        liftd  = 0.0d0
        liftdd = 0.0d0
c       
        do ie = 1,nedge
          if(boun(ie).eq.1) then
            in1 = edge(1,ie)
            in2 = edge(2,ie)
            ic2 = ecell(2,ie)
            call lift_wall_dx2(
     &            x(1,in1),xd0(1,in1),xd(1,in1),xdd(1,in1),
     &            x(1,in2),xd0(1,in2),xd(1,in2),xdd(1,in2),
     &            q(1,ic2),qd0(1,ic2),qd(1,ic2),qdd(1,ic2),
     &            lift,liftd0,liftd,liftdd)
          endif
        enddo
c
        do ipde = 1,4
          maxres(ipde)    = 0.0d0
          maxresd(ipde)   = 0.0d0
          maxresd0(ipde)  = 0.0d0
        enddo
c
        liftdd1 = liftdd
c
c-------Adding resdd contribution to liftdd.
c
        do ic = 1, ncell-1
          do ipde = 1,4
            liftdd = liftdd + qb(ipde,ic)*resdd(ipde,ic)
          enddo
        enddo
c
c-------Calculating maximum nonlinear and linear residues.
c
        do ic = 1, ncell-1
          do ipde = 1,4
            if(maxresd0(ipde).lt.abs(resd0(ipde,ic))) then
              maxresd0(ipde) = abs(resd0(ipde,ic))
            endif
            if(maxresd(ipde).lt.abs(resd(ipde,ic))) then
              maxresd(ipde) = abs(resd(ipde,ic))
            endif
            if(maxres(ipde).lt.abs(res(ipde,ic))) then
              maxres(ipde) = abs(res(ipde,ic))
            endif
          enddo
        enddo
c
        hes(il1,il2) = liftdd
c
      enddo
      enddo
c
      write(*,100) (maxres(ipde),ipde=1,4)
c
      write(*,100) (maxresd(ipde),ipde=1,4)
c
      write(*,100) (maxresd0(ipde),ipde=1,4)
c
 100  format(e23.16,' ',e23.16,' ',e23.16,' ',e23.16)
c
      do il1=1,3
        do il2=1,3
          print*,il1,il2,'            ',hes(il1,il2)
        enddo
      enddo
c
      stop
      end
