ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                   c
c      Run file to run all the subroutines in sequence              c
c                                                                   c
c      Copyright Devendra Ghate and Mike Giles, 2006                c
c      but can be freely used with due acknowledgement              c
c                                                                   c
c      Tapenade developed by Laurent Hascoet and others at INRIA    c
c                                                                   c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
       program run
       implicit none
c
       integer i,iter,flag,j,tmp1,tmp2
       character*100 comm
       character*30  outFile,outDir
       real*8 res,lift,dcoef(3),stepsize(3),
     &        dlift(3),lin(3),hes(3,3),dirhes(3,3)
     &        ,temp(3,10),tmp,tmpres(4)
c
       stepsize(1) = 0.0001d0
       stepsize(2) = 0.0001d0
       stepsize(3) = 0.0001d0

c
c Calling the nonlinear solution code
c
       write(comm,*) "rm -rf baseline"
       call system(comm)
       write(comm,*) "mkdir baseline"
       call system(comm)
c
       print*,'-------Baseline Nonlinear Solution-------'
c
       write(outFile,*) "resf"
c
       call nonlin_sol(outFile,lift)
c
       write(comm,*) "cp flow.dat baseline/flow.dat"
       call system(comm)
       write(comm,*) "cp grid.dat baseline/grid.dat"
       call system(comm)
       write(comm,*) "mv resf baseline/resf"
       call system(comm)
c      
       print*,''
       print*,''
c
c Checks on the linear and the adjoint codes
c
       print*,'-------Linear/Adjoint checks-------'
c
       write(comm,*) "./testlinadj"
       call system(comm)
       print*,''
       print*,''
c
c Calling the linear solution code
c
       print*,'-------Baseline Linear Solution: Mode 1-------'
c
       write(outFile,*) "reslin1"
c
       flag = 1
       call lin_sol(flag,outFile,dlift(1))
c
       write(comm,*) "mv flow_lin.dat baseline/flow_lin1.dat"
       call system(comm)
       write(comm,*) "mv reslin1 baseline/reslin1"
       call system(comm)
c         
       print*,''
       print*,''
c
       print*,'-------Baseline Linear Solution: Mode 2-------'
c
       write(outFile,*) "reslin2"
c
       write(comm,*) "cp baseline/flow.dat ."
       call system(comm)
c
       flag = 2
       call lin_sol(flag,outFile,dlift(2))
c
       write(comm,*) "mv flow_lin.dat baseline/flow_lin2.dat"
       call system(comm)
       write(comm,*) "mv reslin2 baseline/reslin2"
       call system(comm)
c
       print*,''
       print*,''
c
       print*,'-------Baseline Linear Solution: Mode 3-------'
c
       write(outFile,*) "reslin3"
c
       write(comm,*) "cp baseline/flow.dat ."
       call system(comm)
c
       flag = 3
       call lin_sol(flag,outFile,dlift(3))
c
       write(comm,*) "mv flow_lin.dat baseline/flow_lin3.dat"
       call system(comm)
       write(comm,*) "mv reslin3 baseline/reslin3"
       call system(comm)
c
       print*,''
       print*,''
c
       print*,'-------Baseline Adjoint Solution-------'
c
       write(outFile,*) "resadj"
c
       write(comm,*) "cp baseline/flow.dat ."
       call system(comm)
c
       call adj_sol(outFile)
c
       write(comm,*) "cp flow_adj.dat baseline/flow_adj.dat"
       call system(comm)
       write(comm,*) "mv resadj baseline/resadj"
       call system(comm)
c
       print*,''
       print*,''
c
c Check between the adjoint and Baseline Linear 2 solutions
c
       print*,'-------Comparison of Adjoint/Linear-2 residues-------'
c
       write(comm,*) "cp baseline/resadj ."
       call system(comm)
       write(comm,*) "cp baseline/reslin2 ."
       call system(comm)
c
       open(1,FILE='reslin2',status='old')
       do i=1,10
         read(1,*) temp(1,i),tmp,temp(2,i)
       enddo 
       close(1)
c
       open(1,FILE='resadj',status='old')
       do i=1,10
         read(1,*) temp(1,i),tmp,temp(3,i)
       enddo 
       close(1)
c
       print*,'Comparison between the lift perturbation for
     &         the first 1000 iterations of the adjoint and
     &         linear-2 solutions'
       print*,''
       print*,'Mode   Linear-2     Adjoint'
       do i=1,10
         write(*,400) temp(1,i), temp(2,i), temp(3,i)
       enddo 
 400   format(' 'i1,'        ',e12.4,'       ',e12.4)
       print*,''
       print*,''
c
       write(comm,*) "rm -f resadj"
       call system(comm)
       write(comm,*) "rm -f reslin2"
       call system(comm)

c
c Direct Hessian Calculation
c
       print*,'-------Hessian Calculation-------'
c
       write(comm,*) "cp baseline/flow_lin1.dat ."
       call system(comm) 
       write(comm,*) "cp baseline/flow_lin2.dat ."
       call system(comm) 
       write(comm,*) "cp baseline/flow_lin3.dat ."
       call system(comm) 
c
       write(comm,*) "./air_hes > reshes"
       call system(comm) 
c
       print*,'Maximum nonlinear and linear residues in the
     &         entire domain'
       open(1,FILE='reshes',status='old')
       do i=1,3
          read(1,*) tmpres(1),tmpres(2),tmpres(3),tmpres(4)
          write(*,500) tmpres(1),tmpres(2),tmpres(3),tmpres(4)
       enddo
       close(1)
 500   format(' 'e12.4,' ',e12.4,' ',e12.4,' ',e12.4)
c
       write(comm,*) "mv reshes baseline/"
       call system(comm) 
c
       print*,''
       print*,''
c
       print*,'-------Finite Difference Calculations-------'
c
       flag = 1
       write(comm,*)"mkdir fd_lin1"
       call system(comm)
       write(outDir,*)"fd_lin1/"
       call nonlin_fd(flag,stepsize(flag),outDir,lin(1),hes(1,1))
c
       flag = 2
       write(comm,*)"mkdir fd_lin2"
       call system(comm)
       write(outDir,*)"fd_lin2/"
       call nonlin_fd(flag,stepsize(flag),outDir,lin(2),hes(1,2))
c
       flag = 3
       write(comm,*)"mkdir fd_lin3"
       call system(comm)
       write(outDir,*)"fd_lin3/"
       call nonlin_fd(flag,stepsize(flag),outDir,lin(3),hes(1,3))
c         
       print*,''
       print*,''
       print*,'-------Summary-------'
       print*,''
       print*,''
c
       print*,'Comparison between the linear solutions and the 
     &         nonlinear FD'
       print*,''
       print*,'Mode   Linear Solution     Nonlinear FD
     &        Percentage Error'
       do i=1,3
          write(*,200) i,dlift(i),lin(i),
     &                    abs((lin(i)-dlift(i))/dlift(i)*100)
       enddo
 200    format(' 'i1,'       ',e23.16,'       ',e23.16,'        ',e12.4)
c
       write(comm,*) "cp baseline/reshes ."
       call system(comm)
c
       open(1,FILE='reshes',status='old')
       do i=1,3
          read(1,*) tmpres(1),tmpres(2),tmpres(3),tmpres(4)
       enddo
       do i=1,3
         do j=1,3
           read(1,*) tmp1,tmp2,dirhes(i,j)
         enddo
       enddo
       close(1)
       write(comm,*) "rm -f reshes"
       call system(comm)
c
       print*,''
       print*,''
       print*,'Comparison between the hessian and the Linear FD'
       print*,''
       print*,'Mode      Hessian Calculation      Linear FD  
     &    Percentage Error'
       do i=1,3
         do j=1,3
           write(*,300) i,j,dirhes(i,j),hes(i,j),
     &        abs((hes(i,j)-dirhes(i,j))/dirhes(i,j)*100)
         enddo
       enddo
 300    format(' 'i1,' ',i1,'        ',e23.16,'          ',e23.16,
     &         '        ',e12.4)
c
       write(comm,*)"cp baseline/flow.dat ."
       call system(comm)
c
       stop
       end
c
       subroutine nonlin_sol(outFile,lift)
       implicit none
c
       integer iter,i
       real*8 res, lift
       character*100 comm
       character*30  outFile
c
       print*,'Starting the nonlinear solution...'
       write(comm,*) "./airfoil >",outFile
       call system(comm)
c
       open(1,file=outFile,status='old')
       do i=1,200000
         read(1,*,err=999,end=999) iter, res, lift
       enddo
 999   close(1)
c
       print*,'Final residue-',res
       print*,'Iterations   -',iter
       print*,'Lift         -',lift
       print*,'Completed the nonlinear solution.'
c
       return
       end
c
       subroutine lin_sol(flag,outFile,dlift)
       implicit none
c
       integer iter,i,flag
       real*8 res, dlift,dcoef(3)
       character*100 comm
       character*30  outFile
c
       do i = 1,3
         dcoef(i) = 0.0d0
       enddo
c
       if(flag.eq.1) then
         dcoef(1) = 1.0d0
       elseif(flag.eq.2) then
         dcoef(2) = datan(1.0d0)/45.0d0
       elseif(flag.eq.3) then
         dcoef(3) = 1.0d0
       endif
c
       open(1,file='dcoef.dat',status='new')
       write(1,*) dcoef(1),dcoef(2),dcoef(3)
       close(1)
c
       print*,'Starting the linear solution...'
c
       write(comm,*) "./air_lin >",outFile
       call system(comm)
       write(comm,*) "rm -f dcoef.dat"
       call system(comm)
c
       open(1,file=outFile,status='old')
       do i=1,200000
         read(1,*,err=888,end=888) iter, res, dlift
       enddo
 888   close(1)
c
       print*,'Final residue-',res
       print*,'Iterations   -',iter
       print*,'dLift        -',dlift
       print*,'Completed the linear solution.'
c
       return
       end
c
       subroutine adj_sol(outFile)
       implicit none
c
       integer iter,i
       real*8 res, dlift
       character*100 comm
       character*30  outFile
c
       print*,'Starting the adjoint solution...'
c
       write(comm,*) "./air_adj >",outFile
       call system(comm)
c
       open(1,file=outFile,status='old')
       do i=1,200000
         read(1,*,err=888,end=888) iter, res, dlift
       enddo
 888   close(1)
c
       print*,'Final residue-',res
       print*,'Iterations   -',iter
       print*,'dLift        -',dlift
       print*,'Completed the adjoint solution.'
c
       return
       end
c
       subroutine nonlin_fd(flag,stepsize,outDir,lin,hes)
       implicit none
c
       integer*4 flag,ic,iter,ipde,flag1
       real*8 stepsize,r,p,mach,coef(3),dcoef(3),dlift(2,3)
       real*8 q(4,9702),res,lift(2),qd(4,9702),lin,hes(3)
       character*200 comm
       character*30 outDir,filename
c
       print*,'Starting nonlinear central difference'
c
       write(comm,*) "cp baseline/flow.dat ."
       call system(comm)
c
       open(1,file='flow.dat',status='old')
       read(1,*) p,r,mach,coef(1),coef(2),coef(3)
       do ic=1, 9702
         read(1,*,err=777,end=777) (q(ipde,ic),ipde=1,4)
       enddo
 777   close(1)
c
       if(flag.eq.1) then
         write(comm,*) "cp baseline/flow_lin1.dat ."
         write(filename,*) "flow_lin1.dat"
       elseif(flag.eq.2) then
         write(comm,*) "cp baseline/flow_lin2.dat ."
         write(filename,*) "flow_lin2.dat"
       elseif(flag.eq.3) then
         write(comm,*) "cp baseline/flow_lin3.dat ."
         write(filename,*) "flow_lin3.dat"
       endif
       call system(comm)
c
       open(1,file=filename,status='old')
       read(1,*) p,r,mach,coef(1),coef(2),coef(3)
       do ic=1, 9702
         read(1,*,err=555,end=555) (qd(ipde,ic),ipde=1,4)
       enddo
 555   close(1)
c
       do ic=1,9702
         do ipde=1,4
           q(ipde,ic) = q(ipde,ic) + stepsize*qd(ipde,ic)
         enddo
       enddo
c
       coef(flag) = coef(flag) + stepsize
c
       open(1,file='flow.dat',status='old')
       write(1,*) p, r, mach, coef(1), coef(2), coef(3)
       do ic = 1, 9702
         write(1,100) (q(ipde,ic),ipde=1,4)
       enddo
 100   format(e23.16,' ',e23.16,' ',e23.16,' ',e23.16)
       close(1)
c
       call nonlin_sol("resf1",lift(1))
       write(comm,*) "mv resf1",outDir
       call system(comm)
c
       flag1 = 1
       call lin_sol(flag1,"reslin11",dlift(1,1))
       write(comm,*)"mv flow_lin.dat flow_lin11.dat"
       call system(comm)
       write(comm,*)"mv flow_lin11.dat",outDir
       call system(comm)
       write(comm,*)"mv reslin11",outDir
       call system(comm)
c
       flag1 = 2
       call lin_sol(flag1,"reslin12",dlift(1,2))
       write(comm,*)"mv flow_lin.dat flow_lin12.dat"
       call system(comm)
       write(comm,*)"mv flow_lin12.dat",outDir
       call system(comm)
       write(comm,*)"mv reslin12",outDir
       call system(comm)
c
       flag1 = 3
       call lin_sol(flag1,"reslin13",dlift(1,3))
       write(comm,*)"mv flow_lin.dat flow_lin13.dat"
       call system(comm)
       write(comm,*)"mv flow_lin13.dat",outDir
       call system(comm)
       write(comm,*)"mv reslin13",outDir
       call system(comm)
c
       write(comm,*)"mv flow.dat flow1.dat"
       call system(comm)
       write(comm,*)"mv flow1.dat",outDir
       call system(comm)
c
       write(comm,*) "cp baseline/flow.dat ."
       call system(comm)
c
       open(1,file='flow.dat',status='old')
       read(1,*) p,r,mach,coef(1),coef(2),coef(3)
       do ic=1, 9702
         read(1,*,err=666,end=666) (q(ipde,ic),ipde=1,4)
       enddo
 666   close(1)
c
       coef(flag) = coef(flag) - stepsize
c
       do ic=1,9702
         do ipde=1,4
           q(ipde,ic) = q(ipde,ic) - stepsize*qd(ipde,ic)
         enddo
       enddo
c
       open(1,file='flow.dat',status='old')
       write(1,*) p, r, mach, coef(1), coef(2), coef(3)
       do ic = 1, 9702
         write(1,100) (q(ipde,ic),ipde=1,4)
       enddo
       close(1)
c
       call nonlin_sol("resf2",lift(2))
       write(comm,*) "mv resf2",outDir
       call system(comm)
c
       flag1 = 1
       call lin_sol(flag1,"reslin21",dlift(2,1))
       write(comm,*)"mv flow_lin.dat flow_lin21.dat"
       call system(comm)
       write(comm,*)"mv flow_lin21.dat",outDir
       call system(comm)
       write(comm,*)"mv reslin21",outDir
       call system(comm)
c
       flag1 = 2
       call lin_sol(flag1,"reslin22",dlift(2,2))
       write(comm,*)"mv flow_lin.dat flow_lin22.dat"
       call system(comm)
       write(comm,*)"mv flow_lin22.dat",outDir
       call system(comm)
       write(comm,*)"mv reslin22",outDir
       call system(comm)
c
       flag1 = 3
       call lin_sol(flag1,"reslin23",dlift(2,3))
       write(comm,*)"mv flow_lin.dat flow_lin23.dat"
       call system(comm)
       write(comm,*)"mv flow_lin23.dat",outDir
       call system(comm)
       write(comm,*)"mv reslin23",outDir
       call system(comm)
c
       write(comm,*)"mv flow.dat flow2.dat"
       call system(comm)
       write(comm,*)"mv flow2.dat",outDir
       call system(comm)
c
       lin = (lift(1) - lift(2))/2.0d0/stepsize
       hes(1) = (dlift(1,1) - dlift(2,1))/2.0d0/stepsize
       hes(2) = (dlift(1,2) - dlift(2,2))/2.0d0/stepsize
       hes(3) = (dlift(1,3) - dlift(2,3))/2.0d0/stepsize
c
       print*,'Direction-',flag
       print*,'Value    -',lin
       print*,'Direction-',flag, 1
       print*,'Value    -',hes(1)
       print*,'Direction-',flag, 2
       print*,'Value    -',hes(2)
       print*,'Direction-',flag, 3
       print*,'Value    -',hes(3)
       print*,''
       print*,''
c
       write(comm,*) "rm -f flow_lin1.dat"
       call system(comm)
       write(comm,*) "rm -f flow_lin2.dat"
       call system(comm)
       write(comm,*) "rm -f flow_lin3.dat"
       call system(comm)
       write(comm,*) "rm -f flow_adj.dat"
       call system(comm)
c
       return
       end
